module TypingImpls

import TAP
import public Quox.Typing
import public Quox.Pretty
import PrettyExtra

import Derive.Prelude
%language ElabReflection


%runElab deriveIndexed "TyContext" [Show]
%runElab deriveIndexed "EqContext" [Show]
%runElab deriveIndexed "NameContexts" [Show]
%runElab derive "Error" [Show]

export
ToInfo Error where
  toInfo err =
    let str = render (Opts 60) $ runPrettyDef $ prettyError True err in
    [("err", str)]
